// Code generated by mockery v2.10.4. DO NOT EDIT.

package mocks

import (
	mock "github.com/stretchr/testify/mock"
	dao "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dao"
)

// BookRepo is an autogenerated mock type for the BookRepo type
type BookRepo struct {
	mock.Mock
}

// CreateBook provides a mock function with given fields: book
func (_m *BookRepo) CreateBook(book dao.Book) (dao.Book, error) {
	ret := _m.Called(book)

	var r0 dao.Book
	if rf, ok := ret.Get(0).(func(dao.Book) dao.Book); ok {
		r0 = rf(book)
	} else {
		r0 = ret.Get(0).(dao.Book)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dao.Book) error); ok {
		r1 = rf(book)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteById provides a mock function with given fields: id
func (_m *BookRepo) DeleteById(id uint) error {
	ret := _m.Called(id)

	var r0 error
	if rf, ok := ret.Get(0).(func(uint) error); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetAll provides a mock function with given fields:
func (_m *BookRepo) GetAll() ([]dao.Book, error) {
	ret := _m.Called()

	var r0 []dao.Book
	if rf, ok := ret.Get(0).(func() []dao.Book); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Book)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetBook provides a mock function with given fields: id
func (_m *BookRepo) GetBook(id uint64) (dao.Book, error) {
	ret := _m.Called(id)

	var r0 dao.Book
	if rf, ok := ret.Get(0).(func(uint64) dao.Book); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Get(0).(dao.Book)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetBooksByCategoryId provides a mock function with given fields: id
func (_m *BookRepo) GetBooksByCategoryId(id uint64) ([]dao.Book, error) {
	ret := _m.Called(id)

	var r0 []dao.Book
	if rf, ok := ret.Get(0).(func(uint64) []dao.Book); ok {
		r0 = rf(id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Book)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// IsBookOwned provides a mock function with given fields: id_user, id_book
func (_m *BookRepo) IsBookOwned(id_user uint64, id_book uint64) (bool, error) {
	ret := _m.Called(id_user, id_book)

	var r0 bool
	if rf, ok := ret.Get(0).(func(uint64, uint64) bool); ok {
		r0 = rf(id_user, id_book)
	} else {
		r0 = ret.Get(0).(bool)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64, uint64) error); ok {
		r1 = rf(id_user, id_book)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SearchBook provides a mock function with given fields: key
func (_m *BookRepo) SearchBook(key string) ([]dao.Book, error) {
	ret := _m.Called(key)

	var r0 []dao.Book
	if rf, ok := ret.Get(0).(func(string) []dao.Book); ok {
		r0 = rf(key)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Book)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(key)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateBook provides a mock function with given fields: id, updateMap
func (_m *BookRepo) UpdateBook(id uint, updateMap map[string]interface{}) (dao.Book, error) {
	ret := _m.Called(id, updateMap)

	var r0 dao.Book
	if rf, ok := ret.Get(0).(func(uint, map[string]interface{}) dao.Book); ok {
		r0 = rf(id, updateMap)
	} else {
		r0 = ret.Get(0).(dao.Book)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint, map[string]interface{}) error); ok {
		r1 = rf(id, updateMap)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}
